// -*- C++ -*-
/*!
 * @file  ARTK_pos.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "ARTK_pos.h"

// Module specification
// <rtc-template block="module_spec">
static const char* artk_pos_spec[] =
  {
    "implementation_id", "ARTK_pos",
    "type_name",         "ARTK_pos",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "hal",
    "category",          "example",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
ARTK_pos::ARTK_pos(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_markerInfoIn("maker_info_out", m_markerInfo),
    m_oni_positionOut("oni_posion", m_oni_position),
    m_escape_positionOut("escape_posion", m_escape_position)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
ARTK_pos::~ARTK_pos()
{
}



RTC::ReturnCode_t ARTK_pos::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("maker_info_out", m_markerInfoIn);
  
  // Set OutPort buffer
  addOutPort("oni_posion", m_oni_positionOut);
  addOutPort("escape_posion", m_escape_positionOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ARTK_pos::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ARTK_pos::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ARTK_pos::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ARTK_pos::onExecute(RTC::UniqueId ec_id)
{
	if (m_markerInfoIn.isNew()){
		//printf("Data_ok\n");
		m_markerInfoIn.read();

		for (int i = 0; i < m_markerInfo.length(); i++) {
			if (m_markerInfo[i].id == 0){
				m_oni_position.data.x = (m_markerInfo[i].markerPoseMatrix[1][3] * -1) + 0.49;
				m_oni_position.data.y = (m_markerInfo[i].markerPoseMatrix[2][3] * -1) + 0.33;
			}
			else if (m_markerInfo[i].id == 68){
				m_escape_position.data.x = (m_markerInfo[i].markerPoseMatrix[1][3] * -1) + 0.49;
				m_escape_position.data.y = (m_markerInfo[i].markerPoseMatrix[2][3] * -1) + 0.33;

			}

			std::cout << "oni[x:" << m_oni_position.data.x << ",y:" << m_oni_position.data.y << "]" << std::endl;
			std::cout << "escape[x:" << m_escape_position.data.x << ",y:" << m_escape_position.data.y << "]" << std::endl;
			std::cout << "\n";
		}
		m_oni_positionOut.write();
		m_escape_positionOut.write();
	}
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ARTK_pos::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ARTK_pos::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ARTK_posInit(RTC::Manager* manager)
  {
    coil::Properties profile(artk_pos_spec);
    manager->registerFactory(profile,
                             RTC::Create<ARTK_pos>,
                             RTC::Delete<ARTK_pos>);
  }
  
};


