// -*- C++ -*-
/*!
 * @file  ImageDecorator.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "ImageDecorator.h"


// Module specification
// <rtc-template block="module_spec">
static const char* imagedecorator_spec[] =
  {
    "implementation_id", "ImageDecorator",
    "type_name",         "ImageDecorator",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Shiotani",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.Chaser_or_Runaway", "0",

    // Widget
    "conf.__widget__.Chaser_or_Runaway", "radio",
    // Constraints
    "conf.__constraints__.Chaser_or_Runaway", "(0, 1)",

    "conf.__type__.Chaser_or_Runaway", "int",

    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
ImageDecorator::ImageDecorator(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_inIn("in", m_in),
    m_inJIn("inJ", m_inJ),
    m_outOut("out", m_out)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
ImageDecorator::~ImageDecorator()
{
}



RTC::ReturnCode_t ImageDecorator::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("in", m_inIn);
  addInPort("inJ", m_inJIn);
  
  // Set OutPort buffer
  addOutPort("out", m_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("Chaser_or_Runaway", m_tag, "0");
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ImageDecorator::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ImageDecorator::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ImageDecorator::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

char buf[64];
RTC::ReturnCode_t ImageDecorator::onExecute(RTC::UniqueId ec_id)
{
	// Vf[^̃`FbN
	if (m_inIn.isNew()) {
		// InPortf[^̓ǂݍ
		m_inIn.read();

		// InPortOutPort̉ʃTCYуC[Wp̊m
		if (m_in.width != m_out.width || m_in.height != m_out.height)
		{
			m_out.width = m_in.width;
			m_out.height = m_in.height;

			m_imageBuff.create(cv::Size(m_in.width, m_in.height), CV_8UC3);
			m_flipImageBuff.create(cv::Size(m_in.width, m_in.height), CV_8UC3);
		}

		// InPort̉摜f[^m_imageBuffɃRs[
		memcpy(m_imageBuff.data, (void *)&(m_in.pixels[0]), m_in.pixels.length());
		if (m_inJIn.isNew() && m_tag == 1){
			m_inJIn.read();
			if (m_inJ.data[0] == 1){
				sprintf_s(buf, sizeof(buf), "WIN");
				//	EBhEɕ\
				cv::putText(m_imageBuff, buf, cv::Point(120, 300), cv::FONT_HERSHEY_TRIPLEX, 7.0, cv::Scalar(0, 0, 255), 10, CV_AA);
			}
		}

		else if (m_inJIn.isNew() && m_tag == 0){
			m_inJIn.read();
			if (m_inJ.data[0] == 1){
				sprintf_s(buf, sizeof(buf), "LOSE");
				//	EBhEɕ\
				cv::putText(m_imageBuff, buf, cv::Point(30, 300), cv::FONT_HERSHEY_TRIPLEX, 7.0, cv::Scalar(255, 0, 0), 10, CV_AA);
			}
		}
		// InPort̉摜f[^𔽓]B m_flipMode 0: X, 1: Y, -1: ̎
		//cv::flip(m_imageBuff, m_flipImageBuff, 1);
		//cv::Mat picInpic (m_imageBuff, m_flipImageBuff, 1);

		// 摜f[^̃TCY擾
		//int len = m_flipImageBuff.channels() * m_flipImageBuff.cols * m_flipImageBuff.rows;
		//int len = m_imageBuff.channels() * m_imageBuff.cols * m_imageBuff.rows;
		int len = m_in.width * m_in.height * m_imageBuff.channels();
		//std::cout << "m_flipImageBuff.channels()" << m_flipImageBuff.channels() << std::endl;

		//std::cout << "m_imageBuff.channels()" << m_imageBuff.channels() << std::endl;

		//printf("%d", te);
		m_out.pixels.length(len);

		// ]摜f[^OutPortɃRs[
		//memcpy((void *)&(m_out.pixels[0]), m_flipImageBuff.data, len);


		memcpy((void *)&(m_out.pixels[0]), m_imageBuff.data, len);


		// ]摜f[^OutPorto͂B
		m_outOut.write();
	}
	
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ImageDecorator::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ImageDecorator::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ImageDecoratorInit(RTC::Manager* manager)
  {
    coil::Properties profile(imagedecorator_spec);
    manager->registerFactory(profile,
                             RTC::Create<ImageDecorator>,
                             RTC::Delete<ImageDecorator>);
  }
  
};


